
#include "cWeapon.h"


#include "cWeapon.h"

#include "cWeapon.h"
#include "cObject.h"

#include "macros.h"

#include <GL/gl.h>

#define DETAIL 0


//--------------------------------

cWeapon::cWeapon() {
    mMountfv = mBasefv = NULL;
    mOwner = NULL;
    mScale = 1.0f;
    mReloading = 0.0f;
    mReadying = 0.0f;
    mFiring = 0.0f;
    mClipsize = 3;
    mDepotsize = 5;
    mAmmo = mClipsize;
    mClips = mDepotsize;
}

int cWeapon::damageAllByCylinder(float* position, float* velocity, float spf, float radius, int roles, float damage) {
    int damaged = 0;

    float *v = velocity;
    float *a = position;
    float b[] = {a[0] - v[0] * spf, a[1] - v[1] * spf, a[2] - v[2] * spf
    };
    //printf("b' %.2f %.2f %.2f\n", b[0],b[1],b[2]);

    float length = sqrt(v[0] * v[0] + v[1] * v[1] + v[2] * v[2]);
    //printf("length %.6f\n", length);

    std::list<cObject*>* role = cWorld::instance->filterByRole(mOwner, roles, true, -1);
    if (role) {
        //printf("roles: \n"); cWorld::instance->printNames(role);
        //printf("roles %i\n", role->size());
        std::list<cObject*>* range = cWorld::instance->filterByRange(mOwner, a, 0.0f, length, -1, role);
        if (range) {
            //printf("range: \n"); cWorld::instance->printNames(range);
            //printf("range %i\n", range->size());
#if 1
            looplist(i, cObject*, *range) {
                // todo: min dist
                cObject::rImpact* imp = ((cObject*) (*i))->damageByBeam(a, b, radius, damage, true);
                if (imp != NULL) {
                    damaged++;
                    delete imp;
                }
            }
#else
            std::list<cObject*>* line = cWorld::instance->filterByBeam(mOwner, a, b, radius*5, -1, range);
            if (line) {
                //printf("line: \n"); cWorld::instance->printNames(line);
                //printf("line %i\n", line->size());
                looplist(i, cObject*, *line) {
                    // todo: min dist
                    cObject::rImpact* imp = ((cObject*)(*i))->damageByBeam(a, b, radius, damage, true);
                    if (imp != NULL) {
                        damaged++;
                        delete imp;
                    }
                }
                // todo: damage nearest target, if not really hit then find next nearest ...
                // Sort them?
                // Binary search through filterByRange?
                delete line;
            }
#endif
            delete range;
        }
        delete role;
    }
    return damaged;
}

//--------------------------------

cMachineGun::cMachineGun() {
    mClipsize = 75;
    mDepotsize = 2;
    mAmmo = mClipsize;
    mClips = mDepotsize;
}

void cMachineGun::fire(tSerial target) {
    if (!ready()) return;
    
    if (mAmmo > 0) {
        mAmmo--;
        if (mAmmo == 0 && mClips != 0) {
            mReloading = 2.5;
        } else {
            mReloading = 0.5;
        }
    }

    float source[16];
    glPushMatrix();
    glLoadIdentity();
    glMultMatrixf(mBasefv);
    if (mMountfv) glMultMatrixf(mMountfv);
    glGetFloatv(GL_MODELVIEW_MATRIX, source);
    glPopMatrix();

    {
        cWeapon::Particle* s = new cWeapon::Particle();
        s->cnt = 4;

        s->pos[0] = source[12];
        s->pos[1] = source[13];
        s->pos[2] = source[14];

        float nrm[3];
        float pos2[] = {0, -1, 0
        };
        applyMatrix2(source, pos2);
        vectorsub(nrm, pos2, s->pos);

        scalarmul(s->vel, nrm, 1.4);
        const float variation = 0.01;
        for (int i = 0; i < 3; i++) s->vel[i] += (50 - (rand() % 100)) * variation;
        mCastoff.push_back(s);
    }


    {
        cWeapon::Particle* s = new cWeapon::Particle();
        s->cnt = 4;

        s->pos[0] = source[12];
        s->pos[1] = source[13];
        s->pos[2] = source[14];

        float nrm[3];
        float pos2[] = {0, 0, -1
        };
        applyMatrix2(source, pos2);
        vectorsub(nrm, pos2, s->pos);

        scalarmul(s->vel, nrm, 200);
        const float variation = 0.03;
        for (int i = 0; i < 3; i++) s->vel[i] += (50 - (rand() % 100)) * variation;
        mShrapnels.push_back(s);

        float len1 = 0.5;
        float len2 = 200;
        float a[] = {
            s->pos[0] + nrm[0] * len1,
            s->pos[1] + nrm[1] * len1,
            s->pos[2] + nrm[2] * len1
        };
        float b[] = {
            s->pos[0] + nrm[0] * len2,
            s->pos[1] + nrm[1] * len2,
            s->pos[2] + nrm[2] * len2
        };

        //printf("a %.2f %.2f %.2f\n", a[0],a[1],a[2]);
        //printf("b %.2f %.2f %.2f\n", b[0],b[1],b[2]);

        const float cylinder_radius = 2.5f;
        const float damage = 10.0f;
        float v[] = {-(b[0] - a[0]), -(b[1] - a[1]), -(b[2] - a[2])
        };
        //float b[] = { a[0] - v[0] * spf, a[1] - v[1] * spf, a[2] - v[2] * spf };
        //printf("v %.2f %.2f %.2f\n", v[0],v[1],v[2]);
        int damaged = this->damageAllByCylinder(a, v, 10.0f, cylinder_radius, (1UL << cObject::COLLIDEABLE) | (1UL << cObject::DAMAGEABLE), damage);
        //printf("Damaged: %i\n", damaged);
    }
}

void cMachineGun::animate(float spf) {
    for (std::list<cWeapon::Particle*>::iterator i = mShrapnels.begin(); i != mShrapnels.end();) {
        cWeapon::Particle* s = *i++;
        s->pos[0] += s->vel[0] * spf;
        s->pos[1] += s->vel[1] * spf;
        s->pos[2] += s->vel[2] * spf;
        s->cnt -= spf;
        if (s->cnt < 0) {
            mShrapnels.remove(s);
            delete s;
        }
    }
    
    for (std::list<cWeapon::Particle*>::iterator i = mCastoff.begin(); i != mCastoff.end();) {
        cWeapon::Particle* s = *i++;
        s->pos[0] += s->vel[0] * spf;
        s->pos[1] += s->vel[1] * spf;
        s->pos[2] += s->vel[2] * spf;
        s->cnt -= spf;
        if (s->cnt < 0) {
            mCastoff.remove(s);
            delete s;
        }
    }

    mReloading -= spf;
    if (mReloading < 0) {
        mReloading = 0.0f;
        if (mAmmo == 0 && mClips != 0) {
            mAmmo = mClipsize;
            if (mClips > 0) mClips--;
        }
    }
}

void cMachineGun::drawSolid() {
    glPushAttrib(GL_ALL_ATTRIB_BITS);
    {
        glDisable(GL_CULL_FACE);
        glPushMatrix();
        {
            if (mBasefv != NULL) glMultMatrixf(this->mBasefv);
            if (mMountfv != NULL) glMultMatrixf(this->mMountfv);
            glRotatef(-90, 1, 0, 0);

            glColor4f(0.3, 0.3, 0.3, 1.0);
            glPushMatrix();
            {
                glTranslatef(0, 0.75, 0);
                glScalef(0.065, 0.75, 0.065);
                glCenterUnitCylinder(7);

            }
            glPopMatrix();

            glColor4f(0.2, 0.3, 0.2, 1.0);
            glPushMatrix();
            {
                glScalef(0.1, 0.14, 0.12);
                glCenterUnitBlock();
            }
            glPopMatrix();

            glColor4f(0.1, 0.1, 0.1, 1.0);
            if (this->ready() == 0 && mAmmo != 0) glRotatef(this->mOwner->mSeconds * 8 * 90, 0, 1, 0);
            int n = 8;
            for (int i = 0; i < n; i++) {
                glPushMatrix();
                {
                    glRotatef(i * 360 / n, 0, 1, 0);
                    glTranslatef(0.075, 0.8, 0);
                    glScalef(0.03, 0.8, 0.03);
                    glCenterUnitCylinder(7);
                }
                glPopMatrix();
            }
        }
        glPopMatrix();
    }
    glPopAttrib();
}

void cMachineGun::drawEffect() {
    glPushMatrix();
    glPushAttrib(GL_ALL_ATTRIB_BITS);

    glLineWidth(2);
    glDisable(GL_CULL_FACE);
    glDisable(GL_LIGHTING);
    glDisable(GL_TEXTURE_2D);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE);
    glDepthMask(GL_FALSE);

    for (std::list<cWeapon::Particle*>::iterator i = mShrapnels.begin(); i != mShrapnels.end();) {
        cWeapon::Particle* s = *i++;
        const float len1 = 0.01;
        const float len2 = 0.02;
        glBegin(GL_LINE_STRIP);
        glColor4f(1, 1, 1, 1);
        glVertex3fv(s->pos);
        glColor4f(1, 1, 0, 1);
        glVertex3f(s->pos[0] - s->vel[0] * len1, s->pos[1] - s->vel[1] * len1, s->pos[2] - s->vel[2] * len1);
        glColor4f(1, 0, 0, 0.3);
        glVertex3f(s->pos[0] - s->vel[0] * len2, s->pos[1] - s->vel[1] * len2, s->pos[2] - s->vel[2] * len2);
        glEnd();
    }

    for (std::list<cWeapon::Particle*>::iterator i = mCastoff.begin(); i != mCastoff.end();) {
        cWeapon::Particle* s = *i++;
        const float len1 = 0.01;
        const float len2 = 0.02;
        glBegin(GL_LINE_STRIP);
        glColor4f(1, 1, 1, 1);
        glVertex3fv(s->pos);
        glColor4f(1, 1, 0, 1);
        glVertex3f(s->pos[0] - s->vel[0] * len1, s->pos[1] - s->vel[1] * len1, s->pos[2] - s->vel[2] * len1);
        glColor4f(1, 0, 0, 0.3);
        glVertex3f(s->pos[0] - s->vel[0] * len2, s->pos[1] - s->vel[1] * len2, s->pos[2] - s->vel[2] * len2);
        glEnd();
    }

    glPopMatrix();
    glPopAttrib();
}

void cMachineGun::drawHUD() {
    float a = 0.9;
    float b = 0.6;
    
    // Ammo
    float i = 0.1;
    float j = 0.9;
    float r = i + (mAmmo / (float)mClipsize) * (j-i);
    glBegin(GL_QUADS);
    glColor4f(1, 1, 0, b);
    glVertex3f(i, j, 0.0);
    glVertex3f(i, i, 0.0);
    glColor4f(1, 0, 0, b);
    glVertex3f(r, i, 0.0);
    glVertex3f(r, j, 0.0);
    glEnd();

    // Clips
    float l = 0.1;
    float h = 0.15;
    r = i + (mClips / (float)mDepotsize) * (j-i);
    glBegin(GL_QUADS);
    glColor4f(0, 0, 0, a);
    glVertex3f(l, i+h, 0.0);
    glVertex3f(l, i, 0.0);
    glColor4f(1, 1, 1, a);
    glVertex3f(r, i, 0.0);
    glVertex3f(r, i+h, 0.0);
    glEnd();
    
    glBegin(GL_LINES);
    glColor4f(1, 1, 0, b);
    glVertex3f(0.25, 0.5, 0.0);
    glColor4f(1, 1, 1, a);
    glVertex3f(0.35, 0.5, 0.0);
    glColor4f(1, 1, 0, b);
    glVertex3f(0.45, 0.5, 0.0);
    glColor4f(1, 1, 1, a);
    glVertex3f(0.55, 0.5, 0.0);
    glColor4f(1, 1, 0, b);
    glVertex3f(0.65, 0.5, 0.0);
    glColor4f(1, 1, 1, a);
    glVertex3f(0.75, 0.5, 0.0);
    glEnd();
}


//--------------------------------

cPlasmaGun::cPlasmaGun() {
    mClipsize = 6;
    mDepotsize = 3;
    mAmmo = mClipsize;
    mClips = mDepotsize;
}

void cPlasmaGun::fire(tSerial target) {
    if (!ready()) return;
    
    if (mAmmo > 0) {
        mAmmo--;
        if (mAmmo == 0 && mClips != 0) {
            mReloading = 3.5;
        } else {
            mReloading = 0.9;
        }
    }

    float source[16];
    glPushMatrix();
    glLoadIdentity();
    glMultMatrixf(mBasefv);
    if (mMountfv) glMultMatrixf(mMountfv);
    glGetFloatv(GL_MODELVIEW_MATRIX, source);
    glPopMatrix();

    cWeapon::Particle* s = new cWeapon::Particle();
    s->cnt = 3;

    s->pos[0] = source[12];
    s->pos[1] = source[13];
    s->pos[2] = source[14];

    float nrm[3];
    float pos2[] = {0, 0, -1
    };
    applyMatrix2(source, pos2);
    vectorsub(nrm, pos2, s->pos);

    scalarmul(s->vel, nrm, 50);
    mShrapnels.push_back(s);
}

void cPlasmaGun::animate(float spf) {
    for (std::list<cWeapon::Particle*>::iterator i = mShrapnels.begin(); i != mShrapnels.end();) {
        cWeapon::Particle* s = *i++;
        s->pos[0] += s->vel[0] * spf;
        s->pos[1] += s->vel[1] * spf;
        s->pos[2] += s->vel[2] * spf;
        s->cnt -= spf;
        if (s->cnt < 0) {
            mShrapnels.remove(s);
            delete s;
        } else {
            int damaged = this->damageAllByCylinder(s->pos, s->vel, spf, 10.0f, (1UL << cObject::COLLIDEABLE) | (1UL << cObject::DAMAGEABLE), 10);
            if (damaged) {
                mShrapnels.remove(s);
                delete s;
            }
        }
    }
    
    mReloading -= spf;
    if (mReloading < 0) {
        mReloading = 0.0f;
        if (mAmmo == 0 && mClips != 0) {
            mAmmo = mClipsize;
            if (mClips > 0) mClips--;
        }
    }
}

void cPlasmaGun::drawSolid() {
    glPushAttrib(GL_ALL_ATTRIB_BITS);
    {
        glDisable(GL_CULL_FACE);
        glPushMatrix();
        {
            if (mBasefv != NULL) glMultMatrixf(this->mBasefv);
            if (mMountfv != NULL) glMultMatrixf(this->mMountfv);
            glRotatef(-90, 1, 0, 0);

            if (this->ready() == 0 && mAmmo != 0) {
                glDisable(GL_LIGHTING);
                glColor4f(0.2, 0.2, 0.3, 1);
                glPushMatrix();
                {
                    glScalef(0.02, 0.02, 0.02);
                    glTranslatef(0, (0.5 + 0.5 * sin(this->mOwner->mSeconds * 1 * 360 * 0.017454))* 1.7 / 0.02, 0);
                    glRotatef(this->mOwner->mSeconds * 2 * 360, 1, 3, 7);
                    glUnitBlock();
                }
                glPopMatrix();
                glColor4f(0.2, 0.3, 0.2, 1);
                glPushMatrix();
                {
                    glScalef(0.02, 0.02, 0.02);
                    glTranslatef(0, (0.5 + 0.5 * cos(this->mOwner->mSeconds * 1 * 360 * 0.017454))* 1.7 / 0.02, 0);
                    glRotatef(this->mOwner->mSeconds * 2 * 360, 1, 3, 7);
                    glUnitBlock();
                }
                glPopMatrix();
                glColor4f(0.3, 0.2, 0.2, 1);
                glPushMatrix();
                {
                    glScalef(0.02, 0.02, 0.02);
                    glTranslatef(0, (0.5 - 0.5 * sin(this->mOwner->mSeconds * 1 * 360 * 0.017454))* 1.7 / 0.02, 0);
                    glRotatef(this->mOwner->mSeconds * 2 * 360, 1, 3, 7);
                    glUnitBlock();
                }
                glPopMatrix();
            }

            glEnable(GL_LIGHTING);
            glColor4f(0.2, 0.2, 0.3, 1.0);
            glPushMatrix();
            {
                glScalef(0.1, 0.14, 0.12);
                glCenterUnitBlock();
            }
            glPopMatrix();

            glColor4f(0.1, 0.1, 0.1, 1.0);
            glPushMatrix();
            {
                glTranslatef(0.0, 0.8, 0);
                glScalef(0.03, 0.8, 0.03);
                glTranslatef(2.0, 0, 0);
                glCenterUnitCylinder(7);
                glTranslatef(-4.0, 0, 0);
                glCenterUnitCylinder(7);
            }
            glPopMatrix();
        }
        glPopMatrix();
    }
    glPopAttrib();
}

void cPlasmaGun::drawEffect() {
    glPushMatrix();
    glPushAttrib(GL_ENABLE_BIT | GL_CURRENT_BIT | GL_ALL_ATTRIB_BITS);

    glDisable(GL_CULL_FACE);
    glDisable(GL_LIGHTING);
    glDisable(GL_TEXTURE_2D);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE);
    glDepthMask(GL_FALSE);

    float n[16];
    glGetTransposeInverseRotationMatrix(n);

    for (std::list<cWeapon::Particle*>::iterator i = mShrapnels.begin(); i != mShrapnels.end();) {
        cWeapon::Particle* s = *i++;
        glPushMatrix();
        glTranslatef(s->pos[0], s->pos[1], s->pos[2]);
        glMultMatrixf(n);
        glColor4f(0.1, 0.1, 0.6, 0.99f);
        glDisk(9, 1.9 * 0.1f);
        glColor4f(0.8, 0.8, 0.1, 0.6f);
        glDisk(7, 1.9 * 0.07f);
        glPopMatrix();
    }

    glPopMatrix();
    glPopAttrib();
}

void cPlasmaGun::drawHUD() {
    float a = 0.9;
    float b = 0.6;
    
    // Ammo
    float i = 0.1;
    float j = 0.9;
    float r = i + (mAmmo / (float)mClipsize) * (j-i);
    glBegin(GL_QUADS);
    glColor4f(1, 1, 0, b);
    glVertex3f(i, j, 0.0);
    glVertex3f(i, i, 0.0);
    glColor4f(1, 0, 0, b);
    glVertex3f(r, i, 0.0);
    glVertex3f(r, j, 0.0);
    glEnd();

    // Clips
    float l = 0.1;
    float h = 0.15;
    r = i + (mClips / (float)mDepotsize) * (j-i);
    glBegin(GL_QUADS);
    glColor4f(0, 0, 0, a);
    glVertex3f(l, i+h, 0.0);
    glVertex3f(l, i, 0.0);
    glColor4f(1, 1, 1, a);
    glVertex3f(r, i, 0.0);
    glVertex3f(r, i+h, 0.0);
    glEnd();

    glBegin(GL_LINES);
    glColor4f(0, 0, 1, b);
    glVertex3f(0.25, 0.5, 0.0);
    glColor4f(1, 1, 1, a);
    glVertex3f(0.75, 0.5, 0.0);
    glEnd();
}


//--------------------------------

cSparkGun::cSparkGun() {
    mClipsize = 7;
    mDepotsize = 2;
    mAmmo = mClipsize;
    mClips = mDepotsize;
}

void cSparkGun::fire(tSerial target) {
    if (!ready()) return;
    
    if (mAmmo > 0) {
        mAmmo--;
        if (mAmmo == 0 && mClips != 0) {
            mReloading = 2.0;
        } else {
            mReloading = 0.8;
        }
    }

    float source[16];
    glPushMatrix();
    glLoadIdentity();
    glMultMatrixf(mBasefv);
    if (mMountfv) glMultMatrixf(mMountfv);
    glGetFloatv(GL_MODELVIEW_MATRIX, source);
    glPopMatrix();

    cWeapon::Particle* s = new cWeapon::Particle();
    s->cnt = 1;

    s->pos[0] = source[12];
    s->pos[1] = source[13];
    s->pos[2] = source[14];

    float nrm[3];
    float pos2[] = {0, 0, -1
    };
    applyMatrix2(source, pos2);
    vectorsub(nrm, pos2, s->pos);

    scalarmul(s->vel, nrm, 30);
    mShrapnels.push_back(s);
}

void cSparkGun::animate(float spf) {
    for (std::list<cWeapon::Particle*>::iterator i = mShrapnels.begin(); i != mShrapnels.end();) {
        cWeapon::Particle* s = *i++;
        s->pos[0] += s->vel[0] * spf;
        s->pos[1] += s->vel[1] * spf;
        s->pos[2] += s->vel[2] * spf;
        s->cnt -= spf;
        if (s->cnt < 0) {
            mShrapnels.remove(s);
            delete s;
        } else {
            int damaged = this->damageAllByCylinder(s->pos, s->vel, spf, 10.0f, (1UL << cObject::COLLIDEABLE) | (1UL << cObject::DAMAGEABLE), 10);
            if (damaged) {
                mShrapnels.remove(s);
                delete s;
            }
        }
    }
    
    mReloading -= spf;
    if (mReloading < 0) {
        mReloading = 0.0f;
        if (mAmmo == 0 && mClips != 0) {
            mAmmo = mClipsize;
            if (mClips > 0) mClips--;
        }
    }
}

void cSparkGun::drawSolid() {
    glPushAttrib(GL_ALL_ATTRIB_BITS);
    {
        glDisable(GL_CULL_FACE);
        glPushMatrix();
        {
            if (mBasefv != NULL) glMultMatrixf(this->mBasefv);
            if (mMountfv != NULL) glMultMatrixf(this->mMountfv);
            glRotatef(-90, 1, 0, 0);

            if (this->ready() == 0 && mAmmo != 0) {
            }

            glColor4f(0.3, 0.2, 0.2, 1.0);
            glPushMatrix();
            {
                glScalef(0.1, 0.14, 0.12);
                glCenterUnitBlock();
            }
            glPopMatrix();

            glEnable(GL_LIGHTING);
            glColor4f(0.1, 0.1, 0.1, 1.0);
            glPushMatrix();
            {
                glTranslatef(0.0, 0.7, 0);
                glScalef(0.1, 0.7, 0.1);
                glCenterUnitCylinder(7);
            }
            glPopMatrix();
        }
        glPopMatrix();
    }
    glPopAttrib();
}

void cSparkGun::drawEffect() {
    glPushMatrix();
    glPushAttrib(GL_ALL_ATTRIB_BITS);

    glDisable(GL_CULL_FACE);
    glDisable(GL_LIGHTING);
    glDisable(GL_TEXTURE_2D);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE);
    glDepthMask(GL_FALSE);

    float n[16];
    glGetTransposeInverseRotationMatrix(n);

    for (std::list<cWeapon::Particle*>::iterator i = mShrapnels.begin(); i != mShrapnels.end();) {
        cWeapon::Particle* s = *i++;
        glPushMatrix();
        glTranslatef(s->pos[0], s->pos[1], s->pos[2]);
        glMultMatrixf(n);
        glColor4f(0.6, 0.1, 0.1, 0.99f);
        glDisk(9 + DETAIL, 5 * 0.1f + 0.006 * (rand() % 100));
        glColor4f(0.9, 0.9, 0.4, 0.99f);
        glDisk(7 + DETAIL, 5 * 0.07f + 0.006 * (rand() % 100));
        glPopMatrix();
    }

    glPopMatrix();
    glPopAttrib();
}

void cSparkGun::drawHUD() {
    float a = 0.9;
    float b = 0.6;
    
    // Ammo
    float i = 0.1;
    float j = 0.9;
    float r = i + (mAmmo / (float)mClipsize) * (j-i);
    glBegin(GL_QUADS);
    glColor4f(1, 1, 0, b);
    glVertex3f(i, j, 0.0);
    glVertex3f(i, i, 0.0);
    glColor4f(1, 0, 0, b);
    glVertex3f(r, i, 0.0);
    glVertex3f(r, j, 0.0);
    glEnd();

    // Clips
    float l = 0.1;
    float h = 0.15;
    r = i + (mClips / (float)mDepotsize) * (j-i);
    glBegin(GL_QUADS);
    glColor4f(0, 0, 0, a);
    glVertex3f(l, i+h, 0.0);
    glVertex3f(l, i, 0.0);
    glColor4f(1, 1, 1, a);
    glVertex3f(r, i, 0.0);
    glVertex3f(r, i+h, 0.0);
    glEnd();
    
    glBegin(GL_LINES);
    glColor4f(1, 1, 0, b);
    glEnd();
}


//--------------------------------

cRaybeam::cRaybeam() {
    mClipsize = 12;
    mDepotsize = 1;
    mAmmo = mClipsize;
    mClips = mDepotsize;
};

void cRaybeam::fire(tSerial target) {
    if (!ready()) return;
    //mReloading = 2.0;
    //mFiring = 0.7;
    //mReloading = raylife;
    
    if (mAmmo > 0) {
        mAmmo--;
        if (mAmmo == 0 && mClips != 0) {
            mReloading = 2.0;
        } else {
            mReloading = 2.0;
            mFiring = 0.7;
        }
    }

    float source[16];
    glPushMatrix();
    glLoadIdentity();
    glMultMatrixf(mBasefv);
    if (mMountfv) glMultMatrixf(mMountfv);
    glGetFloatv(GL_MODELVIEW_MATRIX, source);
    glPopMatrix();

    {
        cWeapon::Particle particle;
        cWeapon::Particle* s = &particle;

        s->pos[0] = source[12];
        s->pos[1] = source[13];
        s->pos[2] = source[14];

        float nrm[3];
        float pos2[] = {0, 0, -1
        };
        applyMatrix2(source, pos2);
        vectorsub(nrm, pos2, s->pos);

        scalarmul(s->vel, nrm, 200);
        /*
        const float variation = 0.03;
        for (int i = 0; i < 3; i++) s->vel[i] += (50 - (rand() % 100)) * variation;
         */
        float len1 = 0.5;
        float len2 = 200;
        float a[] = {
            s->pos[0] + nrm[0] * len1,
            s->pos[1] + nrm[1] * len1,
            s->pos[2] + nrm[2] * len1
        };
        float b[] = {
            s->pos[0] + nrm[0] * len2,
            s->pos[1] + nrm[1] * len2,
            s->pos[2] + nrm[2] * len2
        };

        //printf("a %.2f %.2f %.2f\n", a[0],a[1],a[2]);
        //printf("b %.2f %.2f %.2f\n", b[0],b[1],b[2]);

        const float cylinder_radius = 2.5f;
        const float damage = 10.0f;
        float v[] = {-(b[0] - a[0]), -(b[1] - a[1]), -(b[2] - a[2])
        };
        //float b[] = { a[0] - v[0] * spf, a[1] - v[1] * spf, a[2] - v[2] * spf };
        //printf("v %.2f %.2f %.2f\n", v[0],v[1],v[2]);
        int damaged = this->damageAllByCylinder(a, v, 50.0f, cylinder_radius, (1UL << cObject::COLLIDEABLE) | (1UL << cObject::DAMAGEABLE), damage);
        //printf("Damaged: %i\n", damaged);
    }
}

void cRaybeam::animate(float spf) {
    mFiring -= spf;
    if (mFiring < 0) mFiring = 0.0f;
    
    mReloading -= spf;
    if (mReloading < 0) {
        mReloading = 0.0f;
        if (mAmmo == 0 && mClips != 0) {
            mAmmo = mClipsize;
            if (mClips > 0) mClips--;
        }
    }
}

void cRaybeam::drawSolid() {
    glPushAttrib(GL_ALL_ATTRIB_BITS);
    {
        glDisable(GL_CULL_FACE);
        glPushMatrix();
        {
            if (mBasefv != NULL) glMultMatrixf(this->mBasefv);
            if (mMountfv != NULL) glMultMatrixf(this->mMountfv);
            glRotatef(-90, 1, 0, 0);

            if (this->ready() == 0 && mAmmo != 0) {
            }

            glColor4f(0.3, 0.2, 0.3, 1.0);
            glPushMatrix();
            {
                glScalef(0.1, 0.14, 0.12);
                glCenterUnitBlock();
            }
            glPopMatrix();

            glEnable(GL_LIGHTING);
            glColor4f(0.1, 0.1, 0.1, 1.0);
            glPushMatrix();
            {
                glTranslatef(0.0, 0.7, 0);
                glScalef(0.03, 0.7, 0.03);
                glCenterUnitCylinder(7);
                glTranslatef(0.0, 1.0, 0);
                glScalef(2.0, 0.1, 2.0);
                glColor4f(0.4, 0.4, 0.4, 1.0);
                glCenterUnitCylinder(7);
            }
            glPopMatrix();
        }
        glPopMatrix();
    }
    glPopAttrib();
}

void cRaybeam::drawEffect() {
    if (mFiring == 0) return;

    const float len = 10;

    struct appearance {
        float width, length;
        float icolor[4];
        float ocolor[4];
    } app[] = {
        0.10, 8 * len,
        {0.3, 0.3, 0.3, 1},
        {0.3, 0.0, 0.0, 1},
        0.40, 8 * len,
        {0.5, 0.5, 0.5, 1},
        {0.3, 0.0, 0.0, 1},
        0.80, 8 * len,
        {0.9, 0.9, 0.9, 1},
        {0.3, 0.0, 0.0, 1},
        0.85, 8 * len,
        {1.0, 1.0, 1.0, 1},
        {0.4, 0.0, 0.0, 1},
        0.90, 8.2 * len,
        {1.0, 1.0, 1.0, 1},
        {0.7, 0.0, 0.0, 1},
        0.60, 8.4 * len,
        {0.9, 0.9, 0.9, 1},
        {0.3, 0.0, 0.0, 1},
        0.30, 8.5 * len,
        {0.7, 0.7, 0.7, 1},
        {0.3, 0.0, 0.0, 1},
    };

    int lifeindex = (int) ((0.7 - mFiring) * 10);
    if (lifeindex > sizeof (app) / sizeof (appearance) - 1) lifeindex = sizeof (app) / sizeof (appearance) - 1;
    if (lifeindex < 0) lifeindex = 0;

    glPushAttrib(GL_ALL_ATTRIB_BITS);
    glDisable(GL_CULL_FACE);
    glDisable(GL_LIGHTING);
    glDisable(GL_TEXTURE_2D);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE);
    glDepthMask(GL_FALSE);

    glPushMatrix();
    glMultMatrixf(this->mBasefv);
    if (mMountfv) glMultMatrixf(this->mMountfv);


    /*
    float m[16];
    glGetFloatv(GL_MODELVIEW_MATRIX, m);
    glPushMatrix();
    glLoadIdentity();
    float right[] = {1,0,0};
    gluLookAt(0,0,0, m[12],m[13],m[14], m[8],m[9],m[10]);
    //gluLookAt(0,0,0, m[12],m[13],m[14], 0,1,0);
    memcpy(right, &m[4], sizeof(float)*3);
    glPopMatrix();
     */

    float m[16];
    glGetFloatv(GL_MODELVIEW_MATRIX, m);
    float* mpnt = &m[12]; // Vector that points to the Mountpoint relative to the eye.
    //printVector(mpnt);
    float* mfwd = &m[8]; // Mountpoint-Forward Vector relative to the eye.
    //printVector(mfwd);

    float right[3];
    cross(right, mpnt, mfwd);
    normalize(right, right);
    //printVector(right);

    //if (mpnt[2] > 0 || mfwd[2] < 0) right[1] = -right[1]; // Correction
    //if (mpnt[1] > 0 || mfwd[1] < 0) right[1] = -right[1]; // Correction


    const float w = app[lifeindex].width;
    right[0] *= -w;
    right[1] *= -w;
    right[2] *= -w;
    glBegin(GL_TRIANGLE_STRIP);
    glColor4fv(app[lifeindex].ocolor);
    glVertex3f(-right[0], -right[1], -right[2] - 2 * w);
    glVertex3f(-right[0], -right[1], -right[2] - app[lifeindex].length);
    glColor4fv(app[lifeindex].icolor);
    glVertex3f(0, 0.0, 0);
    glVertex3f(0, 0.0, -app[lifeindex].length);
    glColor4fv(app[lifeindex].ocolor);
    glVertex3f(+right[0], +right[1], +right[2] - 2 * w);
    glVertex3f(+right[0], +right[1], +right[2] - app[lifeindex].length);
    glEnd();

    glPopMatrix();
    glPopAttrib();
};

void cRaybeam::drawHUD() {
    float a = 0.9;
    float b = 0.6;
    
    // Ammo
    float i = 0.1;
    float j = 0.9;
    float r = i + (mAmmo / (float)mClipsize) * (j-i);
    glBegin(GL_QUADS);
    glColor4f(1, 1, 0, b);
    glVertex3f(i, j, 0.0);
    glVertex3f(i, i, 0.0);
    glColor4f(1, 0, 0, b);
    glVertex3f(r, i, 0.0);
    glVertex3f(r, j, 0.0);
    glEnd();

    // Clips
    float l = 0.1;
    float h = 0.15;
    r = i + (mClips / (float)mDepotsize) * (j-i);
    glBegin(GL_QUADS);
    glColor4f(0, 0, 0, a);
    glVertex3f(l, i+h, 0.0);
    glVertex3f(l, i, 0.0);
    glColor4f(1, 1, 1, a);
    glVertex3f(r, i, 0.0);
    glVertex3f(r, i+h, 0.0);
    glEnd();

    glBegin(GL_LINES);
    glColor4f(1, 0.3, 0.3, b);
    glVertex3f(0.25, 0.5, 0.0);
    glColor4f(1, 0.6, 0.6, a);
    glVertex3f(0.75, 0.5, 0.0);
    glEnd();
}

//--------------------------------

cHomingMissile::cHomingMissile() {
    mClipsize = 4;
    mDepotsize = 3;
    mAmmo = mClipsize;
    mClips = mDepotsize;
}

void cHomingMissile::fire(tSerial target) {
    if (!ready()) return;
    
    if (mAmmo > 0) {
        mAmmo--;
        if (mAmmo == 0 && mClips != 0) {
            mReloading = 2.0;
        } else {
            mReloading = 0.8;
        }
    }

    if (target == 0) {
        target = this->mOwner->enemyNearby();
    }

    float source[16];
    glPushMatrix();
    glLoadIdentity();
    glMultMatrixf(mBasefv);
    if (mMountfv) glMultMatrixf(mMountfv);
    glGetFloatv(GL_MODELVIEW_MATRIX, source);
    glPopMatrix();

    cWeapon::ParticleTrail* s = new cWeapon::ParticleTrail();
    s->target = target;
    s->fuel = 4;
    s->nextsmoke = 0.0f;
    s->timer = 0.0f;

    s->pos[0] = source[12];
    s->pos[1] = source[13];
    s->pos[2] = source[14];

    float nrm[3];
    float pos2[] = {0, 0, -1
    };

    // Variation of direction.
    //pos2[0] += (100-(rand()%200)) * 0.005;
    //pos2[1] += (100-(rand()%200)) * 0.005 + 0.1;
    //pos2[2] += (100-(rand()%200)) * 0.01;

    applyMatrix2(source, pos2);
    vectorsub(nrm, pos2, s->pos);

    scalarmul(s->vel, nrm, 1);
    mMissiles.push_back(s);
}

void cHomingMissile::animate(float spf) {
    for (std::list<cWeapon::ParticleTrail*>::iterator i = mMissiles.begin(); i != mMissiles.end();) {
        cWeapon::ParticleTrail* s = *i++;

        // Update Particle from Missile Trails.
        bool removed_smoke = false;
        for (std::list<cWeapon::Particle*>::iterator j = s->trail.begin(); j != s->trail.end();) {
            cWeapon::Particle* smoke = *j++;
            smoke->cnt -= spf;
            smoke->timer += spf;
            if (smoke->cnt < 0) {
                s->trail.remove(smoke);
                removed_smoke = true;
            }
        }

        const int MAX_SMOKE = 300;
        // Add new Smoke-Particle whenever an old Smoke-Particel disappears
        // or at specified intervals.
        s->nextsmoke -= spf;
        if (s->nextsmoke <= 0 || removed_smoke) {
            s->nextsmoke = 0.04;
            cWeapon::Particle* smoke = new cWeapon::Particle();
            memcpy(smoke->pos, s->pos, sizeof (float) *3);
            smoke->cnt = 0.9f;
            smoke->timer = 0.0f;
            s->trail.push_back(smoke);
        }

        // Now update the Missile itself
        if (s->target) {
            cObject *targetobject = cWorld::instance->mIndex[s->target];
            if (targetobject && true) {
                float tgt[] = {0, 0, 0
                };
                memcpy(tgt, targetobject->mPos, sizeof (float) *3);
                float dir[] = {tgt[0] - s->pos[0], tgt[1] - s->pos[1], tgt[2] - s->pos[2]
                };
                normalize(dir, dir);
                normalize(s->vel, s->vel);
                const float alpha = 0.96;
                loop3i(s->vel[i] = (s->vel[i] * alpha + dir[i]*(1 - alpha)));
            }
        }
        normalize(s->vel, s->vel);
        const float speed = 30;
        s->pos[0] += speed * s->vel[0] * spf;
        s->pos[1] += speed * s->vel[1] * spf;
        s->pos[2] += speed * s->vel[2] * spf;
        s->fuel -= spf;
        s->timer += spf;

        // When fuel is empty just let the Missile and all
        // it's Smoke-Particles disappear.
        if (s->fuel < 0) {
            for (std::list<cWeapon::Particle*>::iterator j = s->trail.begin(); j != s->trail.end();) {
                cWeapon::Particle* smoke = *j++;
                s->trail.remove(smoke);
            }
            mMissiles.remove(s);
            delete s;
        } else {
            float v[] = {speed * s->vel[0], speed * s->vel[1], speed * s->vel[2]
            };
            int damaged = this->damageAllByCylinder(s->pos, v, spf, 5.0f, (1UL << cObject::COLLIDEABLE) | (1UL << cObject::DAMAGEABLE), 10);
            if (damaged) {
                mMissiles.remove(s);
                delete s;
            }
        }
    }
    
    mReloading -= spf;
    if (mReloading < 0) {
        mReloading = 0.0f;
        if (mAmmo == 0 && mClips != 0) {
            mAmmo = mClipsize;
            if (mClips > 0) mClips--;
        }
    }
};

void cHomingMissile::drawSolid() {
    // Missile barrels

    glPushAttrib(GL_ALL_ATTRIB_BITS);
    {
        glDisable(GL_CULL_FACE);
        glPushMatrix();
        {
            if (mBasefv != NULL) glMultMatrixf(this->mBasefv);
            if (mMountfv != NULL) glMultMatrixf(this->mMountfv);
            glRotatef(-90, 1, 0, 0);

            glColor4f(0.3, 0.3, 0.3, 1.0);
            glPushMatrix();
            {
                glTranslatef(0, 0.75, 0);
                glScalef(0.065, 0.75, 0.065);
                glCenterUnitCylinder(7);

            }
            glPopMatrix();

            glColor4f(0.3, 0.3, 0.2, 1.0);
            glPushMatrix();
            {
                glScalef(0.1, 0.14, 0.12);
                glCenterUnitBlock();
            }
            glPopMatrix();

            glColor4f(0.1, 0.1, 0.1, 1.0);
            if (this->ready() == 0 && mAmmo != 0) glRotatef(this->mOwner->mSeconds * 1 * 90, 0, 1, 0);
            int n = 4;
            for (int i = 0; i < n; i++) {
                glPushMatrix();
                {
                    glRotatef(i * 360 / n, 0, 1, 0);
                    glTranslatef(0.075, 0.8, 0);
                    glScalef(0.06, 0.8, 0.06);
                    glCenterUnitCylinder(7);
                }
                glPopMatrix();
            }
        }
        glPopMatrix();
    }
    glPopAttrib();

    // Missiles themselves:
    glPushMatrix();
    glPushAttrib(GL_ALL_ATTRIB_BITS);

    glDisable(GL_CULL_FACE);
    glDisable(GL_LIGHTING);
    glDisable(GL_TEXTURE_2D);

    const float size = 0.8;
    const float length = size * 1.4;
    const float radius = size * 0.2;
    const float s1 = radius * sin(0 * PI_OVER_180);
    const float c1 = radius * cos(0 * PI_OVER_180);
    const float s2 = radius * sin(120 * PI_OVER_180);
    const float c2 = radius * cos(120 * PI_OVER_180);
    const float s3 = radius * sin(240 * PI_OVER_180);
    const float c3 = radius * cos(240 * PI_OVER_180);

    float m[16];
    glGetFloatv(GL_MODELVIEW_MATRIX, m);
    glColor4f(0.7, 0.7, 0.7, 1.0);

    for (std::list<cWeapon::ParticleTrail*>::iterator i = mMissiles.begin(); i != mMissiles.end();) {
        cWeapon::ParticleTrail* s = *i++;

        float r[3];
        cross(r, s->vel, (&m[4]));
        float u[3];
        cross(u, s->vel, r);
        float b[16];
        memset(b, 0, sizeof (float) *16);
        b[15] = 1;
        memcpy(&b[0], r, sizeof (float) *3);
        memcpy(&b[4], u, sizeof (float) *3);
        memcpy(&b[8], s->vel, sizeof (float) *3);
        //printMatrix(b);

        glPushMatrix();
        glTranslatef(s->pos[0], s->pos[1], s->pos[2]);
        glMultMatrixf(b);
        //glNormAxis();
        glBegin(GL_TRIANGLE_FAN);
        glVertex3f(0, 0, length);
        glVertex3f(s1, c1, 0);
        glVertex3f(s2, c2, 0);
        glVertex3f(s3, c3, 0);
        glVertex3f(s1, c1, 0);
        glEnd();
        glPopMatrix();
    }

    glPopMatrix();
    glPopAttrib();
}

void cHomingMissile::drawEffect() {
    //return;

    glPushMatrix();
    glPushAttrib(GL_ALL_ATTRIB_BITS);

    glDisable(GL_CULL_FACE);
    glDisable(GL_LIGHTING);
    glDisable(GL_TEXTURE_2D);
    glDepthMask(GL_FALSE);

    float n[16];
    glGetTransposeInverseRotationMatrix(n);

    // Draw Missile's flare.
    glBlendFunc(GL_SRC_ALPHA, GL_ONE);
    for (std::list<cWeapon::ParticleTrail*>::iterator i = mMissiles.begin(); i != mMissiles.end();) {
        cWeapon::ParticleTrail* s = *i++;

        glPushMatrix();
        glTranslatef(s->pos[0], s->pos[1], s->pos[2]);
        glMultMatrixf(n);
        float size = 2.5 + 2.5 * 0.01f * (rand() % 100);
        glColor4f(0.8, 0.5, 0.1, 0.99f);
        glDisk(9 + DETAIL, size * 0.1f);
        size = 2.5 + 2.5 * 0.01f * (rand() % 100);
        glColor4f(0.9, 0.9, 0.9, 0.99f);
        glDisk(7 + DETAIL, size * 0.07f);
        glPopMatrix();
    }

    // Draw Missile's trails.
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    for (std::list<ParticleTrail*>::iterator i = mMissiles.begin(); i != mMissiles.end();) {
        ParticleTrail* s = *i++;

        for (std::list<cWeapon::Particle*>::iterator j = s->trail.begin(); j != s->trail.end();) {
            cWeapon::Particle* smoke = *j++;
            glPushMatrix();
            glTranslatef(smoke->pos[0], smoke->pos[1], smoke->pos[2]);
            glMultMatrixf(n);
            float m = 2 * smoke->cnt;
            glColor4f(m, m * 0.8, m * 0.6, 0.05 + smoke->cnt);
            float size = 0.1 + 0.2 * pow(1.0f + smoke->timer, 2.0);
            glDisk(5 + DETAIL, size);
            glPopMatrix();
        }
    }

    glPopMatrix();
    glPopAttrib();
}

void cHomingMissile::drawHUD() {
    float a = 0.9;
    float b = 0.6;
    
    // Ammo
    float i = 0.1;
    float j = 0.9;
    float r = i + (mAmmo / (float)mClipsize) * (j-i);
    glBegin(GL_QUADS);
    glColor4f(1, 1, 0, b);
    glVertex3f(i, j, 0.0);
    glVertex3f(i, i, 0.0);
    glColor4f(1, 0, 0, b);
    glVertex3f(r, i, 0.0);
    glVertex3f(r, j, 0.0);
    glEnd();

    // Clips
    float l = 0.1;
    float h = 0.15;
    r = i + (mClips / (float)mDepotsize) * (j-i);
    glBegin(GL_QUADS);
    glColor4f(0, 0, 0, a);
    glVertex3f(l, i+h, 0.0);
    glVertex3f(l, i, 0.0);
    glColor4f(1, 1, 1, a);
    glVertex3f(r, i, 0.0);
    glVertex3f(r, i+h, 0.0);
    glEnd();

    glBegin(GL_LINES);
    glColor4f(0.3, 1, 0.3, b);
    glVertex3f(0.4, 0.4, 0.0);
    glVertex3f(0.6, 0.6, 0.0);
    glVertex3f(0.6, 0.4, 0.0);
    glVertex3f(0.4, 0.6, 0.0);
    glVertex3f(0.5, 0.4, 0.0);
    glVertex3f(0.5, 0.6, 0.0);
    glVertex3f(0.4, 0.5, 0.0);
    glVertex3f(0.6, 0.5, 0.0);
    glEnd();
}


//--------------------------------

cExplosion::cExplosion() {
}

void cExplosion::fire(tSerial target) {
    if (!ready()) return;
    mReloading = 3.8;

    // Shoot several shrapnels around.
    for (int i = 0; i < 15; i++) {

        float source[16];
        glPushMatrix();
        glLoadIdentity();
        if (mBasefv) glMultMatrixf(mBasefv);
        else if (mOwner) glTranslatef(mOwner->mPos[0], mOwner->mPos[1], mOwner->mPos[2]);
        if (mMountfv) glMultMatrixf(mMountfv);
        glGetFloatv(GL_MODELVIEW_MATRIX, source);
        glPopMatrix();

        cWeapon::ParticleTrail* s = new cWeapon::ParticleTrail();
        s->target = target;
        s->fuel = 4 * 2;
        s->nextsmoke = 0.0f;
        s->timer = 0.0f;

        s->pos[0] = source[12];
        s->pos[1] = source[13];
        s->pos[2] = source[14];

        float nrm[3];
        float pos2[] = {0, 0, -1
        };

        pos2[0] = (100 - (rand() % 200)) * 0.01;
        pos2[1] = 0.4 + (100 - (rand() % 200)) * 0.01;
        pos2[2] = (100 - (rand() % 200)) * 0.01;

        applyMatrix2(source, pos2);
        vectorsub(nrm, pos2, s->pos);

        scalarmul(s->vel, nrm, 1);
        mMissiles.push_back(s);
    } // for
}

void cExplosion::animate(float spf) {
    for (std::list<cWeapon::ParticleTrail*>::iterator i = mMissiles.begin(); i != mMissiles.end();) {
        ParticleTrail* s = *i++;

        // Update Smoke from Missile Trails.
        bool removed_smoke = false;
        for (std::list<cWeapon::Particle*>::iterator j = s->trail.begin(); j != s->trail.end();) {
            Particle* smoke = *j++;
            smoke->cnt -= spf;
            smoke->timer += spf;
            if (smoke->cnt < 0) {
                s->trail.remove(smoke);
                removed_smoke = true;
            }
        }

        const int MAX_SMOKE = 100;
        // Add new Smoke-Particle whenever an old Smoke-Particel disappears
        // or at specified intervals.
        s->nextsmoke -= spf;
        if (s->nextsmoke <= 0 || removed_smoke) {
            s->nextsmoke = 0.12;
            cWeapon::Particle* smoke = new cWeapon::Particle();
            memcpy(smoke->pos, s->pos, sizeof (float) *3);
            smoke->cnt = 1.2f;
            smoke->timer = 0.0f;
            s->trail.push_back(smoke);
        }

        const float alpha = 0.992;
        loop3i(s->vel[i] *= alpha);

        const float speed = 5;
        s->pos[0] += speed * s->vel[0] * spf;
        s->pos[1] += speed * s->vel[1] * spf;
        s->pos[2] += speed * s->vel[2] * spf;
        s->fuel -= spf;
        s->timer += spf;

        // When fuel is empty just let the Missile and all
        // it's Smoke-Particles disappear.
        if (s->fuel < 0) {
            for (std::list<cWeapon::Particle*>::iterator j = s->trail.begin(); j != s->trail.end();) {
                cWeapon::Particle* smoke = *j++;
                s->trail.remove(smoke);
            }
            mMissiles.remove(s);
            delete s;
        } else {
            float v[] = {speed * s->vel[0], speed * s->vel[1], speed * s->vel[2]
            };
            int damaged = this->damageAllByCylinder(s->pos, v, spf, 5.0f, (1UL << cObject::COLLIDEABLE) | (1UL << cObject::DAMAGEABLE), 10);
            if (damaged) {
                mMissiles.remove(s);
                delete s;
            }
        }
    }

    mReloading -= spf;
    if (mReloading < 0) mReloading = 0.0f;
};

void cExplosion::drawSolid() {
    glPushMatrix();
    glPushAttrib(GL_ALL_ATTRIB_BITS);

    glDisable(GL_CULL_FACE);
    glDisable(GL_LIGHTING);
    glDisable(GL_TEXTURE_2D);

    glColor4f(0.7, 0.7, 0.7, 1.0);

    const float size = 0.8;
    const float length = size * 0.4;
    const float radius = size * 0.8;
    const float s1 = radius * sin(0 * PI_OVER_180);
    const float c1 = radius * cos(0 * PI_OVER_180);
    const float s2 = radius * sin(120 * PI_OVER_180);
    const float c2 = radius * cos(120 * PI_OVER_180);
    const float s3 = radius * sin(240 * PI_OVER_180);
    const float c3 = radius * cos(240 * PI_OVER_180);

    float m[16];
    glGetFloatv(GL_MODELVIEW_MATRIX, m);

    for (std::list<cWeapon::ParticleTrail*>::iterator i = mMissiles.begin(); i != mMissiles.end();) {
        cWeapon::ParticleTrail* s = *i++;

        float r[3];
        cross(r, s->vel, (&m[4]));
        float u[3];
        cross(u, s->vel, r);
        float b[16];
        memset(b, 0, sizeof (float) *16);
        b[15] = 1;
        memcpy(&b[0], r, sizeof (float) *3);
        memcpy(&b[4], u, sizeof (float) *3);
        memcpy(&b[8], s->vel, sizeof (float) *3);
        //printMatrix(b);

        glPushMatrix();
        glTranslatef(s->pos[0], s->pos[1], s->pos[2]);
        glMultMatrixf(b);
        //glNormAxis();
        glBegin(GL_TRIANGLE_FAN);
        glVertex3f(0, 0, length);
        glVertex3f(s1, c1, 0);
        glVertex3f(s2, c2, 0);
        glVertex3f(s3, c3, 0);
        glVertex3f(s1, c1, 0);
        glEnd();
        glPopMatrix();
    }

    glPopMatrix();
    glPopAttrib();
}

void cExplosion::drawEffect() {
    //return;

    glPushMatrix();
    glPushAttrib(GL_ALL_ATTRIB_BITS);

    glDisable(GL_CULL_FACE);
    glDisable(GL_LIGHTING);
    glDisable(GL_TEXTURE_2D);
    glDepthMask(GL_FALSE);

    float n[16];
    glGetTransposeInverseRotationMatrix(n);

    // Draw Missile's flare.
    glBlendFunc(GL_SRC_ALPHA, GL_ONE);
    for (std::list<ParticleTrail*>::iterator i = mMissiles.begin(); i != mMissiles.end();) {
        ParticleTrail* s = *i++;

        glPushMatrix();
        glTranslatef(s->pos[0], s->pos[1], s->pos[2]);
        glMultMatrixf(n);
        float size = 2.5 + 2.5 * 0.01f * (rand() % 100);
        glColor4f(0.8, 0.5, 0.1, 0.99f);
        glDisk(9 + DETAIL, size * 0.1f);
        size = 2.5 + 2.5 * 0.01f * (rand() % 100);
        glColor4f(0.9, 0.9, 0.9, 0.99f);
        glDisk(7 + DETAIL, size * 0.07f);
        glPopMatrix();
    }

    // Draw Missile's trails.
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    for (std::list<ParticleTrail*>::iterator i = mMissiles.begin(); i != mMissiles.end();) {
        ParticleTrail* s = *i++;

        for (std::list<Particle*>::iterator j = s->trail.begin(); j != s->trail.end();) {
            Particle* smoke = *j++;
            glPushMatrix();
            glTranslatef(smoke->pos[0], smoke->pos[1], smoke->pos[2]);
            glMultMatrixf(n);
            float m = 2 * smoke->cnt;
            glColor4f(m, m * 0.8, m * 0.6, 0.07 + smoke->cnt);
            float size = 0.1 + 0.3 * pow(1.0f + smoke->timer, 3.5);
            glDisk(5 + DETAIL, size);
            glPopMatrix();
        }
    }

    glPopMatrix();
    glPopAttrib();
}


